/***************************************************************************
 *   Copyright (C) 2004 by Work@                                           *
 *   jstubbs@work-at.co.jp                                                 *
 *                                                                         *
 *   This program may be distributed under the terms of the Q Public       *
 *   License as defined by Trolltech AS of Norway and appearing in the     *
 *   file LICENSE.QPL included in the packaging of this file.              *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  *
 ***************************************************************************/

#ifndef __MANAGER_H__
#define __MANAGER_H__

#include <qobject.h>
#include <qstring.h>

#include "datatypes.h"
#include "cache.h"

class Manager
	: public QObject
{
	Q_OBJECT
	
	signals:
		void itemAvailable(Item);
		void itemLoading();
		void noItems();
	
	public slots:
		void setSites(SiteList);
		void jump(QString);
		void next();
		void previous();
	
	protected slots:
		void receiveItems(QString, ItemList);
		void progress(QString, int);
		void modifyUrl(QString prev, QString curr);
	
	public:
		Manager(Cache* cache, QObject* parent = 0, const char* name = 0);
	
	private:
		void getData();
		
		Cache* cache;
		QStringList urls;
		QString url;
		int index;
};

#endif
